VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "NntpClient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Public Server$
Public LastError$

Event ListGroups(group As String)
Event ListArticles(id As Long)

Private firstline%, answer%, request%, lines$
Private WithEvents Socket As CSocket
Attribute Socket.VB_VarHelpID = -1

Private Sub Class_Initialize()
Set Socket = New CSocket
Socket.LineSeparator = vbCrLf
Server$ = ""
LastError$ = ""
End Sub

Private Sub Class_Terminate()
Disconnect
Set Socket = Nothing
End Sub

Public Function Connect%()

If Socket.State = sockConnected Then Disconnect

answer% = 0: firstline% = 0: request% = 0: LastError$ = ""

Socket.Connect Server$, 119
Do While Socket.State = sockConnecting: DoEvents: Loop
If Socket.State <> sockConnected Then Connect% = False: Exit Function

Do Until answer% <> 0: DoEvents: Loop
Connect% = (answer% = 1)

End Function

Public Function GetAllGroups%()

GetAllGroups% = False
If Socket.State <> sockConnected Then LastError$ = "NotConnected.": Exit Function

GetAllGroups% = nntpcommand%("LIST", 1)

End Function

Public Function GetMessages%(group$)

GetMessages% = False
If Not nntpcommand%("GROUP " + group$, 0) Then Exit Function
If Not nntpcommand%("LISTGROUP", 2) Then Exit Function

ids$ = lines$
Do While Len(ids$)
   id$ = parse$(ids$, vbCrLf)
   RaiseEvent ListArticles(Val(id$))
Loop

GetMessages% = True

End Function

Public Function GetMessage$(id&)

If nntpcommand%("ARTICLE " & id&, 2) Then
   GetMessage$ = lines$
Else
   GetMessage$ = LastError$
End If

End Function

Public Function GetMessageSubject$(id&)

nntpcommand "HEAD " & id&, 3
GetMessageSubject$ = lines$

End Function

Public Function GetMessageBody$(id&)

If nntpcommand%("BODY " & id&, 2) Then
   GetMessageBody$ = lines$
Else
   GetMessageBody$ = LastError$
End If

End Function

Public Sub Disconnect()

If Socket.State = sockConnected Then
   nntpcommand "QUIT", 0
   Socket.Disconnect
End If

End Sub

Private Function nntpcommand%(cmd$, r%)
nntpcommand% = False
If Socket.State <> sockConnected Then LastError$ = "Not Connected.": Exit Function
firstline% = 0: answer% = 0: request% = r%: lines$ = "": LastError$ = ""
'Debug.Print "> "; cmd$
Socket.SendData cmd$
Do Until answer% <> 0: DoEvents: Loop
nntpcommand% = (answer% = 1)
End Function

Private Function parse$(a$, ch$)
ai% = InStr(a$, ch$)
If ai% = 0 Then
  parse$ = a$: a$ = ""
Else
  parse$ = Left$(a$, ai% - 1): a$ = Mid$(a$, ai% + Len(ch$))
End If
End Function

Private Sub SOCKET_ERROR(Error As Long, Description As String)
LastError$ = Description
End Sub

Private Sub Socket_LineDataArrival(LineData As String, RemoteHostIP As String)

If LineData = "." Then
   answer% = 1  'fertig & ok
Else
   If firstline% = 0 Then
      firstline% = 1
      'Debug.Print "< "; LineData
      If request% = 0 And Val(parse$((LineData), " ")) < 300 Then answer% = 1
      If Val(parse$((LineData), " ")) > 400 Then answer% = 2: LastError$ = LineData
   ElseIf request% = 1 Then
      RaiseEvent ListGroups(LineData)
   ElseIf request% = 2 Then
      lines$ = lines$ + LineData + vbCrLf
   ElseIf request% = 3 Then
      If LCase$(Left$(LineData, 8)) = "subject:" And lines$ = "" Then lines$ = Trim$(Mid$(LineData, 9))
   End If
End If

End Sub


