VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "TalkConnection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Private WithEvents Socket As CSocket
Attribute Socket.VB_VarHelpID = -1

Private Sub Class_Initialize()
Set Socket = New CSocket
Socket.LineSeparator = vbCrLf
End Sub

Public Sub Init(Server As CSocket)
Socket.Accept Server
TalkForm.L_Protokoll.AddItem Socket.RemoteHost & ":" & Socket.RemotePort & " (connected)"
TalkForm.L_Protokoll.TopIndex = TalkForm.L_Protokoll.ListCount - 1
End Sub

Private Sub Socket_Closed()
TalkForm.L_Protokoll.AddItem Socket.RemoteHost & ":" & Socket.RemotePort & " (disconnected)"
TalkForm.L_Protokoll.TopIndex = TalkForm.L_Protokoll.ListCount - 1

Set Socket = Nothing
For n% = 1 To TalkForm.Clients.Count
   If TalkForm.Clients(n%) Is Me Then TalkForm.Clients.Remove n%: Exit For
Next
End Sub

Private Sub Socket_LineDataArrival(LineData As String, RemoteHostIP As String)
   
TalkForm.L_Protokoll.AddItem Socket.RemoteHost & ":" & Socket.RemotePort & "> " & LineData
TalkForm.L_Protokoll.TopIndex = TalkForm.L_Protokoll.ListCount - 1

If UCase$(LineData) = "DATE" Then
   Socket.SendData Date$
ElseIf UCase$(LineData) = "TIME" Then
   Socket.SendData Time$
ElseIf UCase$(LineData) = "QUIT" Then
   Socket.Disconnect: Socket_Closed
Else
   Socket.SendData "Unknown Command: " + LineData
End If
End Sub
